'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fs = require('fs');
var crypto = require('crypto');
var assert = require('assert');
var merge = require('lodash/merge');
var Stride = require('./stride');
var modeTypes = require('../utils/constants').mode;

/**
 * Class to read the config details, encrypt the migration file content
 * and initialize the stride object
 */

var Strider = function () {
    function Strider(data) {
        _classCallCheck(this, Strider);

        assert.notEqual(data.path, null);
        assert.notEqual(-1, ['up', 'down', 'expired'].indexOf(data.mode));
        this.path = data.path;
        this.mode = data.mode;
        this.content = null;
        this.checksum = null;
        this.key = 'mongo-cop';
        this.encoding = 'utf8';
        this.algo = 'sha1';
        this.digest = 'hex';
    }

    _createClass(Strider, [{
        key: 'readNcrypt',
        value: function readNcrypt() {
            this.content = fs.readFileSync(this.path, { encoding: this.encoding });
            this.checksum = crypto.createHmac(this.algo, this.key).update(this.content).digest(this.digest);
            return this;
        }
    }, {
        key: 'getStride',
        value: function getStride() {
            var obj = require(this.path);
            if (this.mode == modeTypes.up || this.mode === modeTypes.down) {
                assert.notEqual(obj[this.mode], null);
            }
            return new Stride(merge(obj, { checksum: this.checksum, mode: this.mode }));
        }
    }]);

    return Strider;
}();

module.exports = Strider;